<template>
    <edit-switcher  class="param_item" ref="switcher" :isEditable="canEdit" :editedValue="editedValue" :edit-config="config"
        :class="validationMsgClass" @edit="checkActiveEdit">
        <template v-slot:editable="{ edit }">
            <span v-if="config.title" class="param_item__title">{{config.title}}:</span>
            <span class="param_item__value" :id="id">
                <template v-if="!edit.active">
                    <n-a v-if="isNA" />
                    <span v-else-if="isStatusIcon">
                        <i :class="value | status_icon"></i>
                    </span>
                    <span v-else-if="isComponent"><slot :name="id"></slot></span>
                    <span v-else>{{formatedValue}}</span>
                </template>
                <dynamic-control v-else :config="edit" :id="id" :init-value="value" v-model="editValue" :is-invalid="validationParams.invalid"
                    :invalid-msg="validationParams.message" max-width="40rem" min-width="0"/>
            </span>
        </template>
    </edit-switcher>
</template>

<script>
import { NoAnswer as NA } from '@bloomio/spa-admin-common/components';
import DynamicControl from '@/components/DynamicControl';
import EditSwitcher from '@/components/EditSwitcher';
import dynamicFilterMixin from '@/mixins/dynamicFilterMixin';
import validationMixin from '@bloomio/spa-admin-common/mixins/validationMixin';

export default {
    name: 'DetailsParamItem',
    components: {
        DynamicControl,
        EditSwitcher,
        NA,
    },
    mixins: [dynamicFilterMixin, validationMixin],
    created() {
        if (this.edit && Object.prototype.hasOwnProperty.call(this.edit, 'restoreValue')) {
            this.editValue = this.edit.restoreValue;
        } else {
            this.editValue = this.value;
        }
    },
    watch: {
        editValue(newVal, oldValue) {
            if (this.$store.getters.validationParams(this.id).invalid) {
                this.$store.commit('clearValidationMessage', this.id);
            }
            if (newVal !== this.value) {
                this.$store.commit('setNewEditValue', { id: this.id, value: newVal });
            } else if (oldValue !== null) {
                this.$store.commit('clearEditValue', this.id);
            }
        },
        validationParams(newVal) {
            if (newVal.invalid) {
                this.$refs.switcher.switchEditMode({ status: true });
            }
        },
    },
    props: {
        config: { // design config
            type: Object,
            required: false,
        },
        id: { // param id
            type: [String, Object],
            required: false,
        },
        value: { // param value from server
            type: null,
            required: false,
        },
    },
    data() {
        return {
            editValue: null, // current edited value
        };
    },
    computed: {
        isNA: vm => (vm.value === '' || vm.value === null || vm.value === undefined || (Array.isArray(vm.value) && !vm.value.length)),
        isComplex: vm => vm.config.complex,
        isComplexLink: vm => vm.isComplex && vm.config.complex.url && (typeof vm.value === 'object'), // 'invite from' param (but no link yet)
        isComponent: vm => vm.config.readFormat === 'slot_component',
        isStatusIcon: vm => vm.config.readFormat === 'status_icon',
        formatedValue: (vm) => {
            if (vm.config.complex) {
                return vm.dynamicFilter(vm.value, vm.config.complex.filter);
            }
            if (vm.id === 'residence_code' && vm.value) {
                return `${vm.value} (${vm.$store.getters.dictionaryValue(vm.id, vm.value)})`;
            }
            return vm.dynamicFilter(vm.value, vm.config.filter);
        },
        canEdit: vm => vm.$store.getters.isEditable(vm.id),
        editedValue: vm => vm.$store.getters.isBasicParamEdited(vm.id),
    },
    methods: {
        /**
         * Reset edited value on deactivating edit-mode
         * @param {Object} event - emited event data
         */
        checkActiveEdit(event) {
            if (!event.active) {
                this.editValue = this.value;
            }
        },
    },
};
</script>

<style lang="stylus" scoped>
.param_item
    display: flex
    font-size: 1.6rem
    background-color: $bg_light_gray
    word-break: break-all

.param_item__value
    display: inline-block
    width: 100%
    margin-right: 1rem
    min-width: 0

.is-invalid .param_item__title
        color: $base_red

.param_item__title
    min-width: 20rem
    margin-right: 2rem
    color: $base_gray
    font-weight: 500
    @media (max-width 600px)
        min-width: 10rem
        margin-right: 1rem

</style>
